#if !defined(AFX_RUNDLG_H__8F4660E1_F4DF_11D1_AFB2_00A0C95713C2__INCLUDED_)
#define AFX_RUNDLG_H__8F4660E1_F4DF_11D1_AFB2_00A0C95713C2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// RunDlg.h : header file
//
#include "TAgentView.h"
#include "Way.h"
#include "Set.h"

#define NOT_DEFINED 99
#define ID_THREAD WM_USER + 15
#define TIMER_PERIOD 250	// Time elphased for SetTimer

#define WM_SUSPEND_SEARCH  WM_USER + 16
#define WM_RESUME_SEARCH   WM_USER + 17
#define WM_RESTART_SEARCH  WM_USER + 18
#define WM_DELETE_SEARCH   WM_USER + 19
#define WM_SAVE_SEARCH     WM_USER + 20

//  Menu Messages:

#define WM_SUSPEND_SEARCH_FROM_MENU  WM_USER + 21
#define WM_RESUME_SEARCH_FROM_MENU   WM_USER + 22
#define WM_RESTART_SEARCH_FROM_MENU  WM_USER + 23
#define WM_DELETE_SEARCH_FROM_MENU   WM_USER + 24
#define WM_SAVE_SEARCH_FROM_MENU     WM_USER + 25
#define WM_DISPATCH_SOLUTION	     WM_USER + 26

//  Thread Messages:

#define WM_SOLUTION_READY			 WM_USER + 27
#define WM_GET_TIME_STR				 WM_USER + 28
//  CLaunchDlg Messages Start at: WM_USER + 40

/////////////////////////////////////////////////////////////////////////////
// CRunDlg dialog

class CRunDlg : public CDialog
{
// Construction
public:
	CRunDlg(CWnd* pParent = NULL);   // standard constructor
	CRunDlg(CTAgentView *pView);
	BOOL Create(UINT Number, CWay *Request);
	UINT GetNumber() { return m_nSearchNumber; }
	UINT GetTimerAvail() { return TimerAvail; }
	CWinThread *GetThreadPtr() { return m_pThread; }
	void SetThreadPtr(CWinThread *Value) { m_pThread = Value; }
	void StartSearchThread(CWay *SearchDef, void *pStack);
	void InitSearchTime(int Minutes, int Seconds, int TCounter) { m_nMinutes = Minutes; m_nSeconds = Seconds; m_nTCounter = TCounter; };
	void GetTimeStr(char *Dest);
	void UpdateFileName(char *FName);
	void ClearFileName() { FileName.Empty(); };

// Dialog Data
	//{{AFX_DATA(CRunDlg)
	enum { IDD = IDD_RUNNING_SEARCH };
	UINT	m_nImprove;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRunDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

private:
	CTAgentView *m_pView;
	UINT m_nSearchNumber;
	UINT m_nBestPostedSum;
	CWinThread *m_pThread;
	int m_nMinutes, m_nSeconds, m_nTCounter;
	char MsgBuffer[80];
	UINT TimerAvail;
	CString FileName;

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CRunDlg)
	afx_msg void OnSuspend();
	afx_msg void OnResume();
	afx_msg void OnDelete();
	afx_msg void OnClose();
	virtual BOOL OnInitDialog();
	afx_msg void OnOptimalSolution();
	afx_msg void OnAllSolutions();
	afx_msg void OnKillfocusImprovement();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnRestart();
	afx_msg void OnSave();
	//}}AFX_MSG
	afx_msg LRESULT OnSuspendSearchFromMenu(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnResumeSearchFromMenu(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnRestartSearchFromMenu(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnDeleteSearchFromMenu(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnGetTimeStr(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnDispatchSolution(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSaveSearch(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RUNDLG_H__8F4660E1_F4DF_11D1_AFB2_00A0C95713C2__INCLUDED_)
