#if !defined(AFX_SOLUTIONDLG_H__2EEE6E71_1863_11D2_AFCE_00A0C95713C2__INCLUDED_)
#define AFX_SOLUTIONDLG_H__2EEE6E71_1863_11D2_AFCE_00A0C95713C2__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// SolutionDlg.h : header file
//
#include "TAgentView.h"
#include "Way.h"
#include "Set.h"

//	File Header Definision for Solutions:
typedef struct tagSOLFILEHEADER{		   //  Used to Hold solution File Header
	char MapName[NAMELENGTH+1];			   /*  Not Longer than NAMELENGTH  */
	long FirstCity;
	long LastCity;
	long NumberOfCities;				   //  Number of Cities to Visit
	char strTime[6];
	BOOL Optimal;
	long Sum;
} SOLFILEHEADER;

//  Messages of Solution Dialog Box:

#define WM_SOLUTION_CLOSE     WM_USER + 50
#define WM_SOLUTION_DISPLAY   WM_USER + 51
#define WM_SOLUTION_PRINT   WM_USER + 52
//  Messages used by CWaitingSolutions start at WM_USER + 60
/////////////////////////////////////////////////////////////////////////////
// CSolutionDlg dialog

class CSolutionDlg : public CDialog
{
// Construction
public:
	CSolutionDlg(CWnd* pParent = NULL);   // standard constructor
	CSolutionDlg(CTAgentView *pView, const CWay *pWay, char *MapName);
	BOOL Create(int Number);
	void GetDescriptionSize(CSize *Size);
	UINT GetNumber() { return SolutionNumber; }
	void UNcheckDispaly();
	CWay *GetSolution() { return m_Solution; }
	char *GetSolutionDesc() { return m_SolutionDesc.GetBuffer(1); }
	char *GetSolutionTime() { return m_SolutionTime.GetBuffer(1); }
	char *GetSolutionMap() { return m_SolutionMap.GetBuffer(1); }
	void SetNumber(int Number);
// Dialog Data
	//{{AFX_DATA(CSolutionDlg)
	enum { IDD = IDD_SOLUTION };
	int		m_MilesDisplayType;
	CString	m_SolutionDesc;
	CString	m_SolutionTime;
	CString	m_SolutionMap;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSolutionDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
private:
	void CreateSolutionDesc();
	CTAgentView *m_pView;
	int SolutionNumber;
	CWay *m_Solution;
	CTAgentDoc *m_pDoc;
	BOOL m_bDisplayed;
	CString FileName;

protected:

	// Generated message map functions
	//{{AFX_MSG(CSolutionDlg)
	afx_msg void OnClose();
	afx_msg void OnCloseClicked();
	virtual BOOL OnInitDialog();
	afx_msg void OnKm();
	afx_msg void OnMiles();
	afx_msg void OnDisplay();
	afx_msg void OnSave();
	afx_msg void OnPrint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SOLUTIONDLG_H__2EEE6E71_1863_11D2_AFCE_00A0C95713C2__INCLUDED_)
