/////////////////////////////////////////////////////////////////////////////
// CStack class
#include <afxtempl.h>
#include "Way.h"
#include "Set.h"
#include "TAgentDoc.h"

#define MAX_STACK_SIZE 100

class CStack : public CPtrArray // < CObArray, CWay *>
{
public:
	CStack();
    // Add element to top of stack    
	void Push(CWay *newElement);
	// Peek at top element of stack
    CWay *Peek()        { return GetSize() ? 0 : (CWay *) GetAt(GetUpperBound()); }
    // Pop top element off stack    
	CWay *Pop();
	BOOL IsNOTEmpty() { return Top; }
	int GetTop() { return Top; }
	BOOL PushSons(const CWay *Way, const CSet &Request, CTAgentDoc *pDoc);
	void Sort(long Low, long High);
	void DisposeStack();
	void *SaveSearchInfo(UINT SearchNumber, char *MapName, CWay *Request, CWay *BestSolution);
	void LoadStack(void *FromFile, const CWay &SearchDef, CWay *Solution);

private:
	int Top;
};