// TAgentView.cpp : implementation of the CTAgentView class
//

#include "stdafx.h"
#include "TAgent.h"

#include "TAgentDoc.h"
#include "TAgentView.h"
#include "LaunchDlg.h"
#include "RunDlg.h"
#include "SolutionDlg.h"
#include "MainFrm.h"
#include "WaitingSolutions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTAgentView

IMPLEMENT_DYNCREATE(CTAgentView, CScrollView)

BEGIN_MESSAGE_MAP(CTAgentView, CScrollView)
	ON_MESSAGE(WM_DELETE_SEARCH,OnDeleteSearch)
	ON_MESSAGE(WM_LAUNCH_SEARCH,OnLaunchSearch)
	ON_MESSAGE(WM_CANCEL_LAUNCH,OnCancelLaunch)
	ON_MESSAGE(WM_SOLUTION_CLOSE,OnCloseSolution)
	ON_MESSAGE(WM_SOLUTION_DISPLAY,OnDisplaySolution)
	ON_MESSAGE(WM_SOLUTION_PRINT,OnSolutionPrint)
	ON_MESSAGE(WM_SOLUTION_READY,OnSolutionReady)
	ON_MESSAGE(WM_WAITING_SOLUTIONS_CLOSE,OnWaitingSolutionsClose)
	ON_MESSAGE(WM_SET_MAX_SOLUTIONS,OnSetMaxSolutions)
	//{{AFX_MSG_MAP(CTAgentView)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_SEARCH_DELETE_DELETE1, OnSearchDeleteDelete1)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_DELETE_DELETE1, OnUpdateSearchDeleteDelete1)
	ON_COMMAND(ID_SEARCH_DELETE_DELETE2, OnSearchDeleteDelete2)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_DELETE_DELETE2, OnUpdateSearchDeleteDelete2)
	ON_COMMAND(ID_SEARCH_DELETE_DELETE3, OnSearchDeleteDelete3)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_DELETE_DELETE3, OnUpdateSearchDeleteDelete3)
	ON_COMMAND(ID_SEARCH_DELETE_DELETE4, OnSearchDeleteDelete4)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_DELETE_DELETE4, OnUpdateSearchDeleteDelete4)
	ON_COMMAND(ID_SEARCH_DELETE_DELETEALL, OnSearchDeleteDeleteall)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_DELETE_DELETEALL, OnUpdateSearchDeleteDeleteall)
	ON_COMMAND(ID_SEARCH_RESUME_RESUME1, OnSearchResumeResume1)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_RESUME_RESUME1, OnUpdateSearchResumeResume1)
	ON_COMMAND(ID_SEARCH_RESUME_RESUME2, OnSearchResumeResume2)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_RESUME_RESUME2, OnUpdateSearchResumeResume2)
	ON_COMMAND(ID_SEARCH_RESUME_RESUME3, OnSearchResumeResume3)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_RESUME_RESUME3, OnUpdateSearchResumeResume3)
	ON_COMMAND(ID_SEARCH_RESUME_RESUME4, OnSearchResumeResume4)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_RESUME_RESUME4, OnUpdateSearchResumeResume4)
	ON_COMMAND(ID_SEARCH_RESUME_RESUMEALL, OnSearchResumeResumeall)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_RESUME_RESUMEALL, OnUpdateSearchResumeResumeall)
	ON_COMMAND(ID_SEARCH_SUSPEND_SUSPEND1, OnSearchSuspendSuspend1)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_SUSPEND_SUSPEND1, OnUpdateSearchSuspendSuspend1)
	ON_COMMAND(ID_SEARCH_SUSPEND_SUSPEND2, OnSearchSuspendSuspend2)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_SUSPEND_SUSPEND2, OnUpdateSearchSuspendSuspend2)
	ON_COMMAND(ID_SEARCH_SUSPEND_SUSPEND3, OnSearchSuspendSuspend3)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_SUSPEND_SUSPEND3, OnUpdateSearchSuspendSuspend3)
	ON_COMMAND(ID_SEARCH_SUSPEND_SUSPEND4, OnSearchSuspendSuspend4)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_SUSPEND_SUSPEND4, OnUpdateSearchSuspendSuspend4)
	ON_COMMAND(ID_SEARCH_SUSPEND_SUSPENDALL, OnSearchSuspendSuspendall)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_SUSPEND_SUSPENDALL, OnUpdateSearchSuspendSuspendall)
	ON_COMMAND(ID_VIEW_HORIZONTAL, OnViewHorizontal)
	ON_UPDATE_COMMAND_UI(ID_VIEW_HORIZONTAL, OnUpdateViewHorizontal)
	ON_COMMAND(ID_VIEW_VERTICAL, OnViewVertical)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VERTICAL, OnUpdateViewVertical)
	ON_COMMAND(ID_VIEW_USER, OnViewUser)
	ON_UPDATE_COMMAND_UI(ID_VIEW_USER, OnUpdateViewUser)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_COMMAND(ID_SOLUTIONS_10, OnSolutions10)
	ON_UPDATE_COMMAND_UI(ID_SOLUTIONS_10, OnUpdateSolutions10)
	ON_COMMAND(ID_SOLUTIONS_20, OnSolutions20)
	ON_UPDATE_COMMAND_UI(ID_SOLUTIONS_20, OnUpdateSolutions20)
	ON_COMMAND(ID_SOLUTIONS_30, OnSolutions30)
	ON_UPDATE_COMMAND_UI(ID_SOLUTIONS_30, OnUpdateSolutions30)
	ON_COMMAND(ID_SOLUTIONS_40, OnSolutions40)
	ON_UPDATE_COMMAND_UI(ID_SOLUTIONS_40, OnUpdateSolutions40)
	ON_COMMAND(ID_SOLUTIONS_ARRANGESOLUTIONS, OnSolutionsArrangesolutions)
	ON_UPDATE_COMMAND_UI(ID_SOLUTIONS_ARRANGESOLUTIONS, OnUpdateSolutionsArrangesolutions)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_COMMAND(ID_SOLUTIONS_CLOSEALL, OnSolutionsCloseall)
	ON_UPDATE_COMMAND_UI(ID_SOLUTIONS_CLOSEALL, OnUpdateSolutionsCloseall)
	ON_UPDATE_COMMAND_UI(ID_APP_ABOUT, OnUpdateAppAbout)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_SEARCH_RESTART_RESTART1, OnSearchRestartRestart1)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_RESTART_RESTART1, OnUpdateSearchRestartRestart1)
	ON_COMMAND(ID_SEARCH_RESTART_RESTART2, OnSearchRestartRestart2)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_RESTART_RESTART2, OnUpdateSearchRestartRestart2)
	ON_COMMAND(ID_SEARCH_RESTART_RESTART3, OnSearchRestartRestart3)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_RESTART_RESTART3, OnUpdateSearchRestartRestart3)
	ON_COMMAND(ID_SEARCH_RESTART_RESTART4, OnSearchRestartRestart4)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_RESTART_RESTART4, OnUpdateSearchRestartRestart4)
	ON_COMMAND(ID_SEARCH_RESTART_RESTARTALL, OnSearchRestartRestartall)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_RESTART_RESTARTALL, OnUpdateSearchRestartRestartall)
	ON_COMMAND(ID_VIEW_CLEANMAP, OnViewCleanmap)
	ON_UPDATE_COMMAND_UI(ID_VIEW_CLEANMAP, OnUpdateViewCleanmap)
	ON_WM_DESTROY()
	ON_COMMAND(ID_SOLUTIONS_POSTSOLUTIONS, OnSolutionsPostsolutions)
	ON_UPDATE_COMMAND_UI(ID_SOLUTIONS_POSTSOLUTIONS, OnUpdateSolutionsPostsolutions)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTAgentView construction/destruction

CTAgentView::CTAgentView()
{
	// TODO: add construction code here

	m_pLaunchDlg = new CLaunchDlg(this);
	m_pWaitingMessageBox = new CWaitingSolutions(this);
	for(UINT i = 0 ; i < MAX_THREADS ; i++)
		m_pRunDlg[i] = new CRunDlg(this);

	m_nWinArrange = ARNG_HORIZONTAL;
	m_bReArrange = FALSE;
	m_MaxSolutions = 10;

	for(i = 0 ; i < MAX_SOLUTIONS ; i++)
		m_pSolutionDlg[i] = NULL;

	m_pDisplayedSolution = NULL;			  //  No Solution is Displayed
	m_pPrintedSolution = NULL;				  //  No Solution is being Printed

	m_pdcMapMemeory = new CDC;                //  Allocate memory for Bitmap Image.
	m_pMapBitmap = new CBitmap;               //  Allocate memeory for Bitmap Structure.

	FileName.Empty();
}

CTAgentView::~CTAgentView()
{
	CWay *pWay;

	delete m_pWaitingMessageBox;
	delete m_pLaunchDlg;
	for(UINT i = 0 ; i < MAX_THREADS ; i++)
		delete m_pRunDlg[i];

	for(i = 0 ; i < MAX_SOLUTIONS ; i++)
		if(m_pSolutionDlg[i])
		   delete m_pSolutionDlg[i];

	while(m_SolutionsList.GetCount()){	 //  Release Memory of List.
		  pWay = (CWay *) m_SolutionsList.RemoveHead();  //  Get Head  and  Remove node from m_SolutionsList
		  delete pWay;			         //  pWay contains SolutionDesc, Delete after Dialog construction
	}

	delete m_pdcMapMemeory;                  //  Release memory of Bitmap Image
	delete m_pMapBitmap;                     //  Release memeory of Bitmap Structure
}

BOOL CTAgentView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTAgentView drawing

void CTAgentView::OnDraw(CDC* pDC)
{
	CTAgentDoc* pDoc = GetDocument();
	CWay *Solution;
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here

	//  Put MAP Bitmap on Screen.
	pDC->SetStretchBltMode(COLORONCOLOR);
	pDC->StretchBlt(m_MapTopLeft.cx, m_MapTopLeft.cy
				   ,m_MapSizeDest.cx, m_MapSizeDest.cy
				   ,m_pdcMapMemeory, 0, 0
				   ,m_MapSizeSource.cx, m_MapSizeSource.cy, SRCCOPY);

	if(m_pDisplayedSolution){				//  Draw Solution on map.
	   char Buffer[80];
	   CPen newPen(PS_SOLID , 2, RGB(255, 0, 0));
	   pDC->SelectObject(&newPen);
	   Solution = m_pDisplayedSolution->GetSolution();

	   Solution->GetSolutionTitle(Buffer, pDoc);	//  Display Tiltle
	   pDC->TextOut(m_MapTopLeft.cx, m_MapTopLeft.cy - m_TextHeight, Buffer);

	   CPoint MapOrigin(m_MapTopLeft.cx,m_MapTopLeft.cy);
	   for(int i = 0; i < Solution->GetNumberOfCities()-1; i++){
		   pDC->MoveTo(MapOrigin + (pDoc->Cities[Solution->GetCity(i)].Cord));
		   pDC->LineTo(MapOrigin + (pDoc->Cities[Solution->GetCity(i+1)].Cord));
	   }
	   //  Add line to Last City
	   pDC->MoveTo(MapOrigin + (pDoc->Cities[Solution->GetCity(i)].Cord));
	   pDC->LineTo(MapOrigin + (pDoc->Cities[Solution->GetLastCity()].Cord));

	   pDC->SelectStockObject(BLACK_PEN);		//  Deselect newPen
	}					//  End if(m_pDisplayedSolution)
}						//  End of OnDraw Message Handler

void CTAgentView::OnInitialUpdate()
{
	BITMAP bmMap;     //  Windows BITMAP data structure for Map
	CSize sizeTotal;
	CRect ClientRect;          //  Gets Screen Size,  End - Variables for BITMAP

	CScrollView::OnInitialUpdate();
	CRect ViewWindowRect;
	TEXTMETRIC TM;
	CDC *dc = this->GetDC();
	dc->GetTextMetrics(&TM);
	m_TextHeight = TM.tmHeight;
	this->GetWindowRect(&ViewWindowRect);
	ReleaseDC(dc);

	for(UINT i = 0 ; i < MAX_THREADS ; i++){
	    OldXLocation[i] = ViewWindowRect.left + (i+2)*m_TextHeight;
	    OldYLocation[i] = ViewWindowRect.top + ((i+2)*m_TextHeight);
	}
	OldXLaunch = ViewWindowRect.left + (i+2)*m_TextHeight;
	OldYLaunch = ViewWindowRect.top + ((i+2)*m_TextHeight);


	// TODO: calculate the total size of this view
	GetClientRect(ClientRect);
	sizeTotal.cx = ClientRect.right;
	sizeTotal.cy = ClientRect.bottom;
	SetScrollSizes(MM_TEXT, sizeTotal);			//  Original Func

	if(m_pdcMapMemeory->GetSafeHdc() == NULL){  //  Construct USA MAP Bitmap
	   CClientDC dc(this);
	   OnPrepareDC(&dc);
	   m_pMapBitmap->LoadBitmap(IDB_USMAP);
	   m_pdcMapMemeory->CreateCompatibleDC(&dc);
	   m_pdcMapMemeory->SelectObject(m_pMapBitmap);
	   m_pMapBitmap->GetObject(sizeof(BITMAP), &bmMap);
	   m_MapSizeSource.cx = bmMap.bmWidth;
	   m_MapSizeSource.cy = bmMap.bmHeight;
	   m_MapSizeDest = m_MapSizeSource;
	   m_MapTopLeft = sizeTotal - m_MapSizeDest;	//  Compute map TopLeft, and save in m_MapTopLeft
	   dc.DPtoLP(&m_MapSizeDest);
	}
}						//  End of OnInitialUpdate Function

/////////////////////////////////////////////////////////////////////////////
// CTAgentView printing

BOOL CTAgentView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	pInfo->SetMaxPage(1);

	return DoPreparePrinting(pInfo);
}

void CTAgentView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CTAgentView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	long VerTextPos = 0;
	CString Buffer;
	char *TextPtr;
	char *EndofLine;
	char *pTotal;
	TEXTMETRIC TM;

	pDC->SetMapMode(MM_TEXT);
	pDC->GetTextMetrics(&TM);

	//  Print Page Header + UnderLine
	Buffer.Empty();
	Buffer.Format("Traveling Agent Solution");
	pDC->TextOut(0, VerTextPos, Buffer.GetBuffer(1));			//  Print Header
	VerTextPos += TM.tmHeight;
	VerTextPos += TM.tmHeight / 8;
	CPen newPen(PS_SOLID , TM.tmHeight / 4, RGB(0, 0, 255));
	pDC->SelectObject(&newPen);
	pDC->MoveTo(0, VerTextPos);
	pDC->LineTo(TM.tmMaxCharWidth * strlen(Buffer.GetBuffer(1)), VerTextPos);

	pDC->SelectStockObject(BLACK_PEN);		//  Deselect newPen

	VerTextPos += (TM.tmHeight / 8)*5;

	Buffer.Empty();
	//  End of Header

	Buffer.Format("Map Name: %s", m_pPrintedSolution->GetSolutionMap());
	pDC->TextOut(0, VerTextPos, Buffer.GetBuffer(1));			//  Print Map Name
	VerTextPos += TM.tmHeight;
	VerTextPos += TM.tmHeight;
	Buffer.Empty();

	m_pPrintedSolution->GetWindowText(Buffer);
	pDC->TextOut(0, VerTextPos, Buffer.GetBuffer(1));			//  Print Solution Header
	VerTextPos += TM.tmHeight;
	VerTextPos += TM.tmHeight;
	Buffer.Empty();

	Buffer.Format("Search %s", m_pPrintedSolution->GetSolutionTime());
	pDC->TextOut(0, VerTextPos, Buffer.GetBuffer(1));			//  Print Solution Time
	VerTextPos += TM.tmHeight;
	VerTextPos += TM.tmHeight;
	Buffer.Empty();

	Buffer.Format("%s", m_pPrintedSolution->GetSolutionDesc());
	TextPtr = Buffer.GetBuffer(1);
	pTotal = strstr(TextPtr, "Total");

	EndofLine = strchr(TextPtr, '\n');
	while(EndofLine){
	  *EndofLine = NULL;
	  pDC->TextOut(0, VerTextPos, TextPtr);			//  Print Solution Description
	  VerTextPos += TM.tmHeight;
	  EndofLine++;
	  while((*EndofLine) && (!isdigit(*EndofLine))) EndofLine++;
	  if(!(*EndofLine)) break;
	  
	  TextPtr = EndofLine;
	  EndofLine = strchr(TextPtr, '\n');
	}										//  End of while(EndoLine...

	VerTextPos += TM.tmHeight;
	
	EndofLine = strchr(pTotal, '\n');
	if(EndofLine) *EndofLine = NULL;

	pDC->TextOut(0, VerTextPos, pTotal);

//  Does Not Work, need to change Mapping Mode in oreder to do this.
//  Therefor I decided not to print the map because of Lake of time.
//	if(m_pDisplayedSolution == m_pPrintedSolution){
//	   CSize Old_m_MapTopLeft = m_MapTopLeft;
//
//	   m_MapTopLeft.cx = pInfo->m_rectDraw.Width();
//	   m_MapTopLeft.cy = pInfo->m_rectDraw.Height();
//	   m_MapTopLeft -= m_MapSizeDest;
//	   m_MapTopLeft.cy -= (TM.tmHeight + (TM.tmHeight / 8));
//
//	   OnDraw(pDC);							//  Draw Map + Solution Path
//	   m_MapTopLeft = Old_m_MapTopLeft;		//  Restore m_MapTopLeft old value
//	   }									//  End of Map Printing
//  End of Map printing

	//  Print Page Footer.
	VerTextPos = pInfo->m_rectDraw.Height() - TM.tmHeight;
	pDC->TextOut(0, VerTextPos, "Traveling Agent, by Aharon Hillel (c) 1998");

	pInfo->m_bContinuePrinting = FALSE;		//  Remove After Debug

//	CScrollView::OnPrint(pDC, pInfo);
}							//  End of CTAgentView::OnPrint Message Handler

void CTAgentView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
	m_pPrintedSolution = NULL;
}

/////////////////////////////////////////////////////////////////////////////
// CTAgentView diagnostics

#ifdef _DEBUG
void CTAgentView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CTAgentView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CTAgentDoc* CTAgentView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTAgentDoc)));
	return (CTAgentDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTAgentView Functions

int CTAgentView::GetNumberOfSolutions(){
	int Total = 0;
	for(int i = 0; i < MAX_SOLUTIONS; i++)
		if(m_pSolutionDlg[i])
		   Total++;

	return Total;
}    //  End of GetNumberOfSolutions Function

void CTAgentView::CompressSolutions(){
	int Empty = -1;
	for(int i = 0; i < MAX_SOLUTIONS; i++){
		if(!m_pSolutionDlg[i])
		   if(Empty == -1) Empty = i;		//  Get index of NULL pointer
		if(Empty != -1)						//  If Empty contains a NULL pointer Index
			if(m_pSolutionDlg[i]){			//  Move Next pointer to Empty location.
			   m_pSolutionDlg[Empty] = m_pSolutionDlg[i];
			   m_pSolutionDlg[Empty]->SetNumber(Empty);  //  Update Dialog Index
			   m_pSolutionDlg[i] = NULL;
			   i = Empty;					//  Update Index to what was Empty location
			   Empty = -1;					//  No Empty locations detected from this point.
			}
	}										//  End of for(int i = 0... Loop
}											//  End of CompressSolutions Function

void CTAgentView::SetSolutionSizeAndPosition(CSolutionDlg *SDlg, BOOL SolutionFromList){
	CDC *dc = SDlg->GetDC();
	int TopGap, DlgWidth;
	CPoint SolutionOffset(0, 0);
	CString strDlgTitle;

	CWnd *WndMap = SDlg->GetDlgItem(IDC_SOLUTION_HEADER);
//	CWnd *WndTime = SDlg->GetDlgItem(IDC_SOLUTION_TIME);
	CWnd *WndDesc = SDlg->GetDlgItem(IDC_SOLUTION_DESCRIPTION);
	CWnd *WndBDisplay = SDlg->GetDlgItem(ID_DISPLAY);
	CWnd *WndBSave = SDlg->GetDlgItem(ID_SAVE);
	CWnd *WndBPrint = SDlg->GetDlgItem(ID_PRINT);
	CWnd *WndRadioGroup = SDlg->GetDlgItem(IDC_RADIO_GROUP);
	CWnd *WndRBmiles = SDlg->GetDlgItem(IDC_MILES);
	CWnd *WndRBkm = SDlg->GetDlgItem(IDC_KM);
	CWnd *WndBClose = SDlg->GetDlgItem(ID_CLOSE);

	CRect ViewRect;

	CRect DlgRect;
	CSize DlgTitleSize;
	CSize DlgDescSize;
	CRect MapRect;
//	CRect TimeRect;
	CRect DescRect;
	CRect BDisplayRect;
	CRect BSaveRect;
	CRect BPrintRect;
	CRect RadioGroupRect;
	CRect RBmilesRect;
	CRect RBkmRect;
	CRect BCloseRect;

	CSize StretchDim(0,0);							//  Contains Window Streatching Dimentions

	this->GetWindowRect(&ViewRect);
	SDlg->GetWindowRect(&DlgRect);
	m_DlgWidth = DlgRect.Width();
	DlgWidth = m_DlgWidth;
	SDlg->GetWindowText(strDlgTitle);
	DlgTitleSize = dc->GetTextExtent(strDlgTitle);
	ReleaseDC(dc);

	if(SolutionFromList){	//  Set Window Offset As 3/4 width and Height * 1.5 of Dialog Header.
	   SolutionOffset.x = DlgRect.Width() - (DlgRect.Width() / 4);
	   SolutionOffset.y = DlgTitleSize.cy + (DlgTitleSize.cy / 2);
	   }
	WndMap->GetWindowRect(&MapRect);
//	WndTime->GetWindowRect(&TimeRect);
	WndDesc->GetWindowRect(&DescRect);
	WndBDisplay->GetWindowRect(&BDisplayRect);
	WndBSave->GetWindowRect(&BSaveRect);
	WndBPrint->GetWindowRect(&BPrintRect);
	WndRadioGroup->GetWindowRect(&RadioGroupRect);
	WndRBmiles->GetWindowRect(&RBmilesRect);
	WndRBkm->GetWindowRect(&RBkmRect);
	WndBClose->GetWindowRect(&BCloseRect);


	TRACE("DlgRect.top = %d, DlgRect.bottom = %d\n", DlgRect.top, DlgRect.bottom);
	TRACE("MapRect.top = %d, MapRect.bottom = %d\n", MapRect.top, MapRect.bottom);
	TRACE("BDisplayRect.top = %d, BDisplayRect.bottom = %d\n", BDisplayRect.top, BDisplayRect.bottom);
	TRACE("DescRect.top = %d, DescRect.bottom = %d\n", DescRect.top, DescRect.bottom);
	if(DlgTitleSize.cx > DlgRect.Width())			  //  Case of Wide Solution Name
	   StretchDim.cx = DlgTitleSize.cx - DlgRect.Width();

	SDlg->GetDescriptionSize(&DlgDescSize);

	if(DlgDescSize.cx > DescRect.Width())
	   if((DlgDescSize.cx - DescRect.Width()) > StretchDim.cx)
		  StretchDim.cx = DlgDescSize.cx - DescRect.Width();

	if(DlgDescSize.cy > DescRect.Height()){
	   if((DlgDescSize.cy - DescRect.Height()) > StretchDim.cy)
		  StretchDim.cy = DlgDescSize.cy - DescRect.Height();
	   DescRect.bottom += (DlgDescSize.cy - DescRect.Height());
	   }

	if(StretchDim.cx){
	   DlgRect.right += StretchDim.cx;
	   DescRect.right += StretchDim.cx;

//	   TimeRect.left +=  StretchDim.cx;
//	   TimeRect.right +=  StretchDim.cx;
	   BDisplayRect.left +=  StretchDim.cx;
	   BDisplayRect.right +=  StretchDim.cx;
	   BSaveRect.left +=  StretchDim.cx;
	   BSaveRect.right +=  StretchDim.cx;
	   BPrintRect.left +=  StretchDim.cx;
	   BPrintRect.right +=  StretchDim.cx;
	   RadioGroupRect.left +=  StretchDim.cx;
	   RadioGroupRect.right +=  StretchDim.cx;
	   RBmilesRect.left +=  StretchDim.cx;
	   RBmilesRect.right +=  StretchDim.cx;
	   RBkmRect.left +=  StretchDim.cx;
	   RBkmRect.right +=  StretchDim.cx;
	   BCloseRect.left +=  StretchDim.cx;
	   BCloseRect.right +=  StretchDim.cx;
	   }

	TRACE("StretchDim.cy = %d\n", StretchDim.cy);

	TopGap = BDisplayRect.top - DlgRect.top;
//	TopGap = abs((DlgRect.bottom - DlgRect.top) - StretchDim.cy);

	if(StretchDim.cy)
	   DlgRect.bottom += StretchDim.cy;

	DescRect.top -= TopGap;
	DescRect.bottom -=  TopGap;

//	TimeRect.top -=  TopGap;
//	TimeRect.bottom -=  TopGap;
	BDisplayRect.top -=  TopGap;
	BDisplayRect.bottom -=  TopGap;
	BSaveRect.top -=  TopGap;
	BSaveRect.bottom -=  TopGap;
	BPrintRect.top -=  TopGap;
	BPrintRect.bottom -=  TopGap;
	RadioGroupRect.top -=  TopGap;
	RadioGroupRect.bottom -=  TopGap;
	RBmilesRect.top -=  TopGap;
	RBmilesRect.bottom -=  TopGap;
	RBkmRect.top -=  TopGap;
	RBkmRect.bottom -=  TopGap;
	BCloseRect.top -=  TopGap;
	BCloseRect.bottom -=  TopGap;

	TRACE("DlgRect.top = %d, DlgRect.bottom = %d\n", DlgRect.top, DlgRect.bottom);
	TRACE("MapRect.top = %d, MapRect.bottom = %d\n", MapRect.top, MapRect.bottom);
	TRACE("BDisplayRect.top = %d, BDisplayRect.bottom = %d\n", BDisplayRect.top, BDisplayRect.bottom);
	TRACE("DescRect.top = %d, DescRect.bottom = %d\n", DescRect.top, DescRect.bottom);

//	WndTime->MoveWindow(&TimeRect);
	WndDesc->MoveWindow(&DescRect);
	WndBDisplay->MoveWindow(&BDisplayRect);
	WndBSave->MoveWindow(&BSaveRect);
	WndBPrint->MoveWindow(&BPrintRect);
	WndRadioGroup->MoveWindow(&RadioGroupRect);
	WndRBmiles->MoveWindow(&RBmilesRect);
	WndRBkm->MoveWindow(&RBkmRect);
	WndBClose->MoveWindow(&BCloseRect);

//	SDlg->MoveWindow(&DlgRect);

	UINT DlgNumber = SDlg->GetNumber();
	DlgWidth *= (DlgNumber / (MAX_SOLUTIONS / 2));
	DlgNumber %= (MAX_SOLUTIONS / 2);

	SDlg->SetWindowPos(&wndNoTopMost
		              ,ViewRect.left + DlgWidth + ((DlgNumber + 2) * m_TextHeight) + SolutionOffset.x
					  ,ViewRect.top + ((DlgNumber + 2) * m_TextHeight) + SolutionOffset.y
					  ,DlgRect.Width(),DlgRect.Height(),SWP_NOACTIVATE | SWP_SHOWWINDOW);

	for(int i = 0 ; i < MAX_THREADS ; i++)				//  Move Search Windows to Top.
		if(IsWindow(m_pRunDlg[i]->GetSafeHwnd())){
		   m_pRunDlg[i]->BringWindowToTop();
		}

	if(IsWindow(m_pLaunchDlg->GetSafeHwnd()))		//  Handling Launch Window
	   m_pLaunchDlg->SetWindowPos(&wndTopMost, 0, 0, 0, 0,SWP_NOSIZE | SWP_SHOWWINDOW | SWP_NOMOVE);

}   //  End of SetSolutionSizeAndPosition Function

void CTAgentView::PostSolutionsFromList(){
	CWay *pWay;
	CWnd *CurrentFocus = GetFocus();
	int SolutionNumber = GetNumberOfSolutions();
	OnSolutionsArrangesolutions();		//  Compress and Arrange Solutions

	while((m_SolutionsList.GetCount()) && (SolutionNumber < m_MaxSolutions)){
	      pWay = (CWay *) m_SolutionsList.RemoveHead();  //  GetHead  and  Remove node from m_SolutionsList
		  m_pSolutionDlg[SolutionNumber] = new CSolutionDlg(this, pWay, GetDocument()->MapHeader.MapName);
		  delete pWay;			            //  pWay contains SolutionDesc, Delete after Dialog construction
		  m_pSolutionDlg[SolutionNumber]->Create(SolutionNumber);

		  SetSolutionSizeAndPosition(m_pSolutionDlg[SolutionNumber], FALSE);
		  SolutionNumber++;
	}							//  End while((!m_SolutionsList...

	SolutionNumber = m_SolutionsList.GetCount();
	if(SolutionNumber){
	   if(IsWindow(m_pWaitingMessageBox->GetSafeHwnd())){
	      m_pWaitingMessageBox->UpdateMessageBox(m_SolutionsList.GetCount());
	      m_pWaitingMessageBox->BringWindowToTop();
		  }
	      else m_pWaitingMessageBox->Create(m_SolutionsList.GetCount());
	   }
	   else if(IsWindow(m_pWaitingMessageBox->GetSafeHwnd()))
			   m_pWaitingMessageBox->DestroyWindow();

	   if(CurrentFocus)
	      if(IsWindow(CurrentFocus->GetSafeHwnd()))
	         ::SetFocus(CurrentFocus->GetSafeHwnd());
}	//  End of PostSolutionsFromList Function

/////////////////////////////////////////////////////////////////////////////
// CTAgentView message handlers
void CTAgentView::OnFileNew() 
{
	// TODO: Add your command handler code here
	if(m_pLaunchDlg->GetSafeHwnd() == 0){
	   m_pLaunchDlg->Create();							//  Display Selection Window
       m_pLaunchDlg->SetListBoxesHScroll();				//  Set Horiz Scroll in ListBoxes
	}

	switch(m_nWinArrange){
		   case ARNG_HORIZONTAL: OnViewHorizontal();
							     break;
		   case ARNG_VERTICAL:   OnViewVertical();
								 break;
		   case ARNG_USER:       OnViewUser();
					             break;
		   default:			     OnViewHorizontal();   //  Default arrangement
	}												   //  End of switch(WinArrange)
}

void CTAgentView::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL NewEnable = FALSE;
	for(UINT i = 0 ; i < MAX_THREADS ; i++)
		if(!(m_pRunDlg[i]->GetThreadPtr())){
		   NewEnable = TRUE;
		   break;
	   }
	
	if(IsWindow(m_pLaunchDlg->GetSafeHwnd()))  // If Selection Dialog is Displayed
	   NewEnable = FALSE;					   // Disable FileNew

	pCmdUI->Enable(NewEnable);
}

void CTAgentView::OnFileOpen() 
{
	// TODO: Add your command handler code here
	CFileDialog FDlg(TRUE, "tas", "*.tas");
	int Selection = IDRETRY;
	FILE *fp;
	CString Msg;
	CMainFrame *pFrame = (CMainFrame *) AfxGetApp()->m_pMainWnd;

	if(FDlg.DoModal() == IDOK){
	   FileName.Empty();
	   FileName = FDlg.GetPathName();

	   Msg.Empty();
	   Msg.Format("%s - Cannot Open file.", FileName.GetBuffer(1));
	   while(Selection == IDRETRY){
		 Selection = IDOK;
	     if((fp = fopen(FileName.GetBuffer(1), "rb")) == NULL)	   //  Save File Header + array of Cities
	        Selection = AfxMessageBox(Msg.GetBuffer(1), MB_ABORTRETRYIGNORE);
	   }
	}				//  End if(FDlg.DoModal() == IDOK)

	if(Selection == IDOK){
	   APPFILEHEADER AppHeader;
	   fread(&AppHeader, sizeof(APPFILEHEADER), 1, fp);	//  Get AppHeader
		  
	   //  Testing Validity of File:
	   if(!strstr(AppHeader.Vertion,"TAV")){
		  fclose(fp);
		  Msg.Empty();
		  Msg.Format("%s - File is NOT in TAgent Format.", FileName.GetBuffer(1));
	      AfxMessageBox(Msg.GetBuffer(1), MB_ICONEXCLAMATION | MB_OK);
	   }

	   long Temp = (AppHeader.Vertion[3]-'0')*10 + (AppHeader.Vertion[5]-'0');
	   switch(Temp){
		 case 10:{
		          switch(AppHeader.FileType){
			      case FT_MAP:{
								Msg.Empty();
								Msg.Format("%s - file is a TAgent MAP file\nCan't change MAP.", FileName.GetBuffer(1));
					            AfxMessageBox(Msg.GetBuffer(1), MB_ICONEXCLAMATION | MB_OK);
							    fclose(fp);
								break;
							  }			//  End of case FT_MAP
				  case FT_SEARCH:{		//  If found a free SearchBox, load Search and Run it.
								   BOOL NewEnable = FALSE;
								   for(UINT i = 0 ; i < MAX_THREADS ; i++)
									   if(!(m_pRunDlg[i]->GetThreadPtr())){		//  Search is Free to use
										  NewEnable = TRUE;
										  break;
									   }

								   if(NewEnable){							   
									  ULONG MemSize;
									  fread(&MemSize, sizeof(long), 1, fp);
									  TRACE("OnFileOpen: MemSize = %ld\n", MemSize);
									  char *InfoPtr = new char[MemSize];
									  fread(InfoPtr, sizeof(char), MemSize, fp);
									  fclose(fp);
									  OnLaunchSearch(SEARCH_FROM_FILE,(long) InfoPtr); //  Start the Search	  
								   }
								   else {
									      Msg.Empty();
										  Msg.Format("%s - file conatins a Tagent Search.\nCannot open another search.", FileName.GetBuffer(1));
										  AfxMessageBox(Msg.GetBuffer(1), MB_ICONEXCLAMATION | MB_OK);
										}
								   break;
								 }			//  End of case FT_SEARCH
				  case FT_SOLUTION:{		//  Load Solution and Display it
								     SOLFILEHEADER FileHeader;
									 fread(&FileHeader, sizeof(SOLFILEHEADER), 1, fp);
									 if(strcmp(FileHeader.MapName, (GetDocument()->MapHeader.MapName))){
										Msg.Empty();
										Msg.Format("%s - file conatins solution from map: %s\nOpen this map first.", FileName.GetBuffer(1), FileHeader.MapName);
										fclose(fp);
										AfxMessageBox(Msg.GetBuffer(1), MB_ICONEXCLAMATION | MB_OK);
										break;
									 }
									 CWay *pWay = new CWay(FileHeader.FirstCity
														  ,FileHeader.LastCity
														  ,FileHeader.NumberOfCities
													      ,FileHeader.Optimal);
									 fread(pWay->GetPath(), sizeof(long), FileHeader.NumberOfCities, fp);
									 fclose(fp);
									 strcpy(pWay->GetstrTime(), FileHeader.strTime);
									 pWay->SetSum(FileHeader.Sum);
									 pWay->SetNextCity(FileHeader.NumberOfCities - 1);
									 OnSolutionReady(TRUE, (long) pWay);			//  Post Solution
									 break;
								   }			//  End of case FT_SOLUTION
				  default: {
							 Msg.Empty();
							 Msg.Format("%s - file Unknown File Type.", FileName.GetBuffer(1));
					         AfxMessageBox(Msg.GetBuffer(1), MB_ICONEXCLAMATION | MB_OK);
							 fclose(fp);
							 break;
						   }				//  End of default
				  }							//  End of switch(AppHeader.FileType)
				  break;
				 }							//  End of case 10

		 default: {
				   fclose(fp);
				   Msg.Empty();
				   Msg.Format("%s - File is a TAgent %s vertion.", FileName.GetBuffer(1), AppHeader.Vertion);
				   strcat(FileName.GetBuffer(1), AppHeader.Vertion);
				   AfxMessageBox(Msg.GetBuffer(1), MB_ICONEXCLAMATION | MB_OK);
				   break;
				  }
	   }								//  End of switch(Temp) statemen
	}									//  End if(Selection == IDOK){
	if(IsWindow(pFrame->GetSafeHwnd()))
	   ::SetFocus(pFrame->GetSafeHwnd());
}										//  End of OnFileOpen Function

void CTAgentView::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL OpenEnable = TRUE;
	
	if(IsWindow(m_pLaunchDlg->GetSafeHwnd()))  // If Selection Dialog is Displayed
	   OpenEnable = FALSE;					   // Disable FileOpen

	pCmdUI->Enable(OpenEnable);	
}

void CTAgentView::OnSearchDeleteDelete1() 
{
	// TODO: Add your command handler code here
    if(IsWindow(m_pRunDlg[0]->GetSafeHwnd()))
	   m_pRunDlg[0]->SendMessage(WM_DELETE_SEARCH_FROM_MENU, ID_SEARCH_DELETE_DELETE1);
/////////////////////////////////////////////////////////////////////
//  Ask why This does not work:  (Program does not loactes PushBottom
//  Return value of  SendDlgItemMessage = 0
//	   m_pRunDlg[0]->SendDlgItemMessage(ID_DELETE , BN_CLICKED, 0, 0)
/////////////////////////////////////////////////////////////////////

}

void CTAgentView::OnUpdateSearchDeleteDelete1(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL DeleteEnable = FALSE;
	
	if(m_pRunDlg[0]->GetThreadPtr())
	   DeleteEnable = TRUE;

	pCmdUI->Enable(DeleteEnable);
}

void CTAgentView::OnSearchDeleteDelete2() 
{
	// TODO: Add your command handler code here
    if(IsWindow(m_pRunDlg[1]->GetSafeHwnd()))
	   m_pRunDlg[1]->SendMessage(WM_DELETE_SEARCH_FROM_MENU, ID_SEARCH_DELETE_DELETE2);
}

void CTAgentView::OnUpdateSearchDeleteDelete2(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL DeleteEnable = FALSE;
	
	if(m_pRunDlg[1]->GetThreadPtr())
	   DeleteEnable = TRUE;

	pCmdUI->Enable(DeleteEnable);	
}

void CTAgentView::OnSearchDeleteDelete3() 
{
	// TODO: Add your command handler code here
    if(IsWindow(m_pRunDlg[2]->GetSafeHwnd()))
	   m_pRunDlg[2]->SendMessage(WM_DELETE_SEARCH_FROM_MENU, ID_SEARCH_DELETE_DELETE3);	
}

void CTAgentView::OnUpdateSearchDeleteDelete3(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL DeleteEnable = FALSE;
	
	if(m_pRunDlg[2]->GetThreadPtr())
	   DeleteEnable = TRUE;

	pCmdUI->Enable(DeleteEnable);	
}

void CTAgentView::OnSearchDeleteDelete4() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[3]->GetSafeHwnd()))
	   m_pRunDlg[3]->SendMessage(WM_DELETE_SEARCH_FROM_MENU, ID_SEARCH_DELETE_DELETE4);
}

void CTAgentView::OnUpdateSearchDeleteDelete4(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL DeleteEnable = FALSE;
	
	if(m_pRunDlg[3]->GetThreadPtr())
	   DeleteEnable = TRUE;

	pCmdUI->Enable(DeleteEnable);	
}

void CTAgentView::OnSearchDeleteDeleteall() 
{
	// TODO: Add your command handler code here
	for(UINT i = 0; i < MAX_THREADS; i++)
	    if(m_pRunDlg[i]->GetThreadPtr())
           if(IsWindow(m_pRunDlg[i]->GetSafeHwnd()))
			  m_pRunDlg[i]->SendMessage(WM_DELETE_SEARCH_FROM_MENU, ID_SEARCH_DELETE_DELETEALL);
}

void CTAgentView::OnUpdateSearchDeleteDeleteall(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL DeleteEnable = FALSE;
	
	for(UINT i = 0; i < MAX_THREADS; i++)
	    if(m_pRunDlg[i]->GetThreadPtr())
	       DeleteEnable = TRUE;

	pCmdUI->Enable(DeleteEnable);	
}

void CTAgentView::OnSearchResumeResume1() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[0]->GetSafeHwnd()))
	   m_pRunDlg[0]->SendMessage(WM_RESUME_SEARCH_FROM_MENU, ID_SEARCH_RESUME_RESUME1);
}

void CTAgentView::OnUpdateSearchResumeResume1(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL ResumeEnable = FALSE;
	if(m_pRunDlg[0]->GetThreadPtr())
	   if(IsWindow(m_pRunDlg[0]->GetSafeHwnd()))
		  if(m_pRunDlg[0]->GetDlgItem(ID_RESUME)->IsWindowEnabled())
			 ResumeEnable = TRUE;

	pCmdUI->Enable(ResumeEnable);	
}

void CTAgentView::OnSearchResumeResume2() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[1]->GetSafeHwnd()))
	   m_pRunDlg[1]->SendMessage(WM_RESUME_SEARCH_FROM_MENU, ID_SEARCH_RESUME_RESUME2);
}

void CTAgentView::OnUpdateSearchResumeResume2(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL ResumeEnable = FALSE;

	if(m_pRunDlg[1]->GetThreadPtr())
	   if(IsWindow(m_pRunDlg[1]->GetSafeHwnd()))
		  if(m_pRunDlg[1]->GetDlgItem(ID_RESUME)->IsWindowEnabled())
			 ResumeEnable = TRUE;

	pCmdUI->Enable(ResumeEnable);	
}	

void CTAgentView::OnSearchResumeResume3() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[2]->GetSafeHwnd()))
	   m_pRunDlg[2]->SendMessage(WM_RESUME_SEARCH_FROM_MENU, ID_SEARCH_RESUME_RESUME2);
}

void CTAgentView::OnUpdateSearchResumeResume3(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL ResumeEnable = FALSE;
	if(m_pRunDlg[2]->GetThreadPtr())
	   if(IsWindow(m_pRunDlg[2]->GetSafeHwnd()))
		  if(m_pRunDlg[2]->GetDlgItem(ID_RESUME)->IsWindowEnabled())
			 ResumeEnable = TRUE;

	pCmdUI->Enable(ResumeEnable);	
}	

void CTAgentView::OnSearchResumeResume4() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[3]->GetSafeHwnd()))
	   m_pRunDlg[3]->SendMessage(WM_RESUME_SEARCH_FROM_MENU, ID_SEARCH_RESUME_RESUME4);
}

void CTAgentView::OnUpdateSearchResumeResume4(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL ResumeEnable = FALSE;

	if(m_pRunDlg[3]->GetThreadPtr())
	   if(IsWindow(m_pRunDlg[3]->GetSafeHwnd()))
		  if(m_pRunDlg[3]->GetDlgItem(ID_RESUME)->IsWindowEnabled())
			 ResumeEnable = TRUE;

	pCmdUI->Enable(ResumeEnable);	
}	

void CTAgentView::OnSearchResumeResumeall() 
{
	// TODO: Add your command handler code here
	for(UINT i = 0; i < MAX_THREADS; i++)
		if(IsWindow(m_pRunDlg[i]->GetSafeHwnd()))
	       if(m_pRunDlg[i]->GetDlgItem(ID_RESUME)->IsWindowEnabled())
		      m_pRunDlg[i]->SendMessage(WM_RESUME_SEARCH_FROM_MENU, ID_SEARCH_RESUME_RESUMEALL);
}

void CTAgentView::OnUpdateSearchResumeResumeall(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL ResumeEnable = FALSE;
	
	for(UINT i = 0; i < MAX_THREADS; i++)
		if(m_pRunDlg[i]->GetThreadPtr())
		   if(IsWindow(m_pRunDlg[i]->GetSafeHwnd()))
			  if(m_pRunDlg[i]->GetDlgItem(ID_RESUME)->IsWindowEnabled())
				 ResumeEnable = TRUE;

	pCmdUI->Enable(ResumeEnable);	
}

void CTAgentView::OnSearchSuspendSuspend1() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[0]->GetSafeHwnd()))
	   m_pRunDlg[0]->SendMessage(WM_SUSPEND_SEARCH_FROM_MENU, ID_SEARCH_SUSPEND_SUSPEND1);	
}

void CTAgentView::OnUpdateSearchSuspendSuspend1(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL SuspendEnable = FALSE;
	
	if(m_pRunDlg[0]->GetThreadPtr())
	   if(IsWindow(m_pRunDlg[0]->GetSafeHwnd()))
	      if(m_pRunDlg[0]->GetDlgItem(ID_SUSPEND)->IsWindowEnabled())
	         SuspendEnable = TRUE;

	pCmdUI->Enable(SuspendEnable);	
}

void CTAgentView::OnSearchSuspendSuspend2() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[1]->GetSafeHwnd()))
	   m_pRunDlg[1]->SendMessage(WM_SUSPEND_SEARCH_FROM_MENU, ID_SEARCH_SUSPEND_SUSPEND2);	
}

void CTAgentView::OnUpdateSearchSuspendSuspend2(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL SuspendEnable = FALSE;

	if(m_pRunDlg[1]->GetThreadPtr())
	   if(IsWindow(m_pRunDlg[1]->GetSafeHwnd()))	
	      if(m_pRunDlg[1]->GetDlgItem(ID_SUSPEND)->IsWindowEnabled())
	         SuspendEnable = TRUE;

	pCmdUI->Enable(SuspendEnable);	
}

void CTAgentView::OnSearchSuspendSuspend3() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[2]->GetSafeHwnd()))
	   m_pRunDlg[2]->SendMessage(WM_SUSPEND_SEARCH_FROM_MENU, ID_SEARCH_SUSPEND_SUSPEND3);
}

void CTAgentView::OnUpdateSearchSuspendSuspend3(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL SuspendEnable = FALSE;
	
	if(m_pRunDlg[2]->GetThreadPtr())
	   if(IsWindow(m_pRunDlg[2]->GetSafeHwnd()))
	      if(m_pRunDlg[2]->GetDlgItem(ID_SUSPEND)->IsWindowEnabled())
	         SuspendEnable = TRUE;

	pCmdUI->Enable(SuspendEnable);	
}

void CTAgentView::OnSearchSuspendSuspend4() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[3]->GetSafeHwnd()))
	   m_pRunDlg[3]->SendMessage(WM_SUSPEND_SEARCH_FROM_MENU, ID_SEARCH_SUSPEND_SUSPEND3);	
}

void CTAgentView::OnUpdateSearchSuspendSuspend4(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL SuspendEnable = FALSE;
	
	if(m_pRunDlg[3]->GetThreadPtr())
	   if(IsWindow(m_pRunDlg[3]->GetSafeHwnd()))
	      if(m_pRunDlg[3]->GetDlgItem(ID_SUSPEND)->IsWindowEnabled())
	         SuspendEnable = TRUE;

	pCmdUI->Enable(SuspendEnable);	
}

void CTAgentView::OnSearchSuspendSuspendall() 
{
	// TODO: Add your command handler code here
	for(UINT i = 0; i < MAX_THREADS; i++)
		if(IsWindow(m_pRunDlg[i]->GetSafeHwnd()))
		   if(m_pRunDlg[i]->GetDlgItem(ID_SUSPEND)->IsWindowEnabled())
		      m_pRunDlg[i]->SendMessage(WM_SUSPEND_SEARCH_FROM_MENU, ID_SEARCH_SUSPEND_SUSPENDALL);
}


void CTAgentView::OnUpdateSearchSuspendSuspendall(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL SuspendEnable = FALSE;
	
	for(UINT i = 0; i < MAX_THREADS; i++)
		if(m_pRunDlg[i]->GetThreadPtr())
		   if(IsWindow(m_pRunDlg[i]->GetSafeHwnd()))
		      if(m_pRunDlg[i]->GetDlgItem(ID_SUSPEND)->IsWindowEnabled())
	             SuspendEnable = TRUE;

	pCmdUI->Enable(SuspendEnable);	
}

void CTAgentView::OnSearchRestartRestart1() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[0]->GetSafeHwnd()))
	   m_pRunDlg[0]->SendMessage(WM_RESTART_SEARCH_FROM_MENU, ID_SEARCH_RESTART_RESTART1);
}

void CTAgentView::OnUpdateSearchRestartRestart1(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL RestartEnable = FALSE;
	
	if(m_pRunDlg[0]->GetThreadPtr())
	   RestartEnable = TRUE;

	pCmdUI->Enable(RestartEnable);		
}

void CTAgentView::OnSearchRestartRestart2() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[1]->GetSafeHwnd()))
	   m_pRunDlg[1]->SendMessage(WM_RESTART_SEARCH_FROM_MENU, ID_SEARCH_RESTART_RESTART2);	
}

void CTAgentView::OnUpdateSearchRestartRestart2(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL RestartEnable = FALSE;
	
	if(m_pRunDlg[1]->GetThreadPtr())
	   RestartEnable = TRUE;

	pCmdUI->Enable(RestartEnable);	
}

void CTAgentView::OnSearchRestartRestart3() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[2]->GetSafeHwnd()))
	   m_pRunDlg[2]->SendMessage(WM_RESTART_SEARCH_FROM_MENU, ID_SEARCH_RESTART_RESTART3);
}

void CTAgentView::OnUpdateSearchRestartRestart3(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL RestartEnable = FALSE;
	
	if(m_pRunDlg[2]->GetThreadPtr())
	   RestartEnable = TRUE;

	pCmdUI->Enable(RestartEnable);	
}

void CTAgentView::OnSearchRestartRestart4() 
{
	// TODO: Add your command handler code here
	if(IsWindow(m_pRunDlg[3]->GetSafeHwnd()))
	   m_pRunDlg[3]->SendMessage(WM_RESTART_SEARCH_FROM_MENU, ID_SEARCH_RESTART_RESTART4);
}

void CTAgentView::OnUpdateSearchRestartRestart4(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL RestartEnable = FALSE;
	
	if(m_pRunDlg[3]->GetThreadPtr())
	   RestartEnable = TRUE;

	pCmdUI->Enable(RestartEnable);	
}

void CTAgentView::OnSearchRestartRestartall() 
{
	// TODO: Add your command handler code here
	for(UINT i = 0; i < MAX_THREADS; i++)
		if(m_pRunDlg[i]->GetThreadPtr())
		   if(IsWindow(m_pRunDlg[i]->GetSafeHwnd()))
		      m_pRunDlg[i]->SendMessage(WM_RESTART_SEARCH_FROM_MENU, ID_SEARCH_SUSPEND_SUSPENDALL);	
}

void CTAgentView::OnUpdateSearchRestartRestartall(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL RestartEnable = FALSE;
	
	for(UINT i = 0; i < MAX_THREADS; i++)
		if(m_pRunDlg[i]->GetThreadPtr())
		   RestartEnable = TRUE;

	pCmdUI->Enable(RestartEnable);		
}

void CTAgentView::OnViewCleanmap() 
{
	// TODO: Add your command handler code here
	OnDisplaySolution(ID_VIEW_CLEANMAP, NULL);
}

void CTAgentView::OnUpdateViewCleanmap(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL CleanmapEnable = FALSE;

	if(m_pDisplayedSolution)
	   CleanmapEnable = TRUE;

	pCmdUI->Enable(CleanmapEnable);

}

void CTAgentView::OnViewHorizontal() 
{
	// TODO: Add your command handler code here
	m_nWinArrange = ARNG_HORIZONTAL;
	CMainFrame *pFrame = (CMainFrame *) AfxGetApp()->m_pMainWnd;
	CToolBar *pToolBar = &pFrame->m_wndToolBar;
	int XPos, XLeft, YPos, YTop;
	CRect ViewWinDim,DialogBoxDim, ToolBarRect;
	GetWindowRect(&ViewWinDim);
	pToolBar->GetWindowRect(&ToolBarRect);
	if(ToolBarRect.Width() > ToolBarRect.Height()){
	   XLeft = 0;
	   YTop = ViewWinDim.top + 1;
	}
	else {
		   if(ToolBarRect.Width() > ToolBarRect.right)
			  XLeft = ToolBarRect.right;
			  else XLeft = 0;
		   YTop = ViewWinDim.top + 1;
	}

	XPos = XLeft;
	YPos = YTop;

	for(UINT i = 0 ; i < MAX_THREADS ; i++)
		if(IsWindow(m_pRunDlg[i]->GetSafeHwnd())){ 
		   m_pRunDlg[i]->GetWindowRect(&DialogBoxDim);
		   m_pRunDlg[i]->MoveWindow(XPos
								   ,YPos
								   ,DialogBoxDim.Width()
								   ,DialogBoxDim.Height());
		   m_pRunDlg[i]->BringWindowToTop();

		   XPos += DialogBoxDim.Width();
		   if((XPos + DialogBoxDim.Width()) > ViewWinDim.right){
			  XPos = XLeft;
			  YPos += DialogBoxDim.Height();
		   }
		}

	if(IsWindow(m_pLaunchDlg->GetSafeHwnd())){		//  Handling Launch Window
	   CRect LaunchDlgDim;
	   m_pLaunchDlg->GetWindowRect(&LaunchDlgDim);  //  if Desplayed.
	   if((XPos + LaunchDlgDim.Width()) > ViewWinDim.right){
			  XPos = XLeft;
			  YPos += DialogBoxDim.Height();
		   }

	   m_pLaunchDlg->SetWindowPos(&wndTopMost, XPos, YPos, 0, 0,SWP_NOSIZE | SWP_SHOWWINDOW);
	}

	m_bReArrange = FALSE;
}

void CTAgentView::OnUpdateViewHorizontal(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL HorizontalEnable = FALSE;
	for(UINT i = 0 ; i < MAX_THREADS ; i++)
		if(IsWindow(m_pRunDlg[i]->GetSafeHwnd())){
	       HorizontalEnable = (m_nWinArrange != ARNG_HORIZONTAL) | m_bReArrange;	
		   break;
		}
		pCmdUI->Enable(HorizontalEnable);
}

void CTAgentView::OnViewVertical() 
{
	// TODO: Add your command handler code here
	CMainFrame *pFrame = (CMainFrame *) AfxGetApp()->m_pMainWnd;
	CToolBar *pToolBar = &pFrame->m_wndToolBar;
	m_nWinArrange = ARNG_VERTICAL;
	int XPos, XLeft, YPos, YTop;
	CRect ViewWinDim,DialogBoxDim, ToolBarRect;
	GetWindowRect(&ViewWinDim);
	pToolBar->GetWindowRect(&ToolBarRect);
	if(ToolBarRect.Width() > ToolBarRect.Height()){
	   XLeft = 0;
	   YTop = ViewWinDim.top + 1;
	}
	else {
		   if(ToolBarRect.Width() > ToolBarRect.right)
			  XLeft = ToolBarRect.right;
			  else XLeft = 0;
		   YTop = ViewWinDim.top + 1;
	}

	XPos = XLeft;
	YPos = YTop;

	for(UINT i = 0 ; i < MAX_THREADS ; i++)
		if(IsWindow(m_pRunDlg[i]->GetSafeHwnd())){
		   m_pRunDlg[i]->GetWindowRect(&DialogBoxDim);
		   m_pRunDlg[i]->MoveWindow(XPos
								   ,YPos
								   ,DialogBoxDim.Width()
								   ,DialogBoxDim.Height());
		   m_pRunDlg[i]->BringWindowToTop();

		   YPos += DialogBoxDim.Height();
		   if((YPos + DialogBoxDim.Height()) > ViewWinDim.bottom){
			  XPos += DialogBoxDim.Width();
			  YPos = YTop;
		   }
		}

	if(IsWindow(m_pLaunchDlg->GetSafeHwnd())){		//  Handling Launch Window
	   CRect LaunchDlgDim;
	   m_pLaunchDlg->GetWindowRect(&LaunchDlgDim);  //  if Desplayed.
	   if((YPos + LaunchDlgDim.Height()) > ViewWinDim.bottom){
			  XPos += DialogBoxDim.Width();
			  YPos = YTop;
		   }
	   m_pLaunchDlg->SetWindowPos(&wndTopMost, XPos, YPos, 0, 0,SWP_NOSIZE | SWP_SHOWWINDOW);
	}

	m_bReArrange = FALSE;
}

void CTAgentView::OnUpdateViewVertical(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL VerticalEnable = FALSE;
	for(UINT i = 0 ; i < MAX_THREADS ; i++)
		if(IsWindow(m_pRunDlg[i]->GetSafeHwnd())){
	       VerticalEnable = (m_nWinArrange != ARNG_VERTICAL) | m_bReArrange;	
		   break;
		}
	pCmdUI->Enable(VerticalEnable);
}

void CTAgentView::OnViewUser() 
{
	// TODO: Add your command handler code here
	int XPos, YPos;
	RECT ViewWinDim,DialogBoxDim;
	m_nWinArrange = ARNG_USER;

	GetWindowRect(&ViewWinDim);
	
	for(UINT i = 0 ; i < MAX_THREADS ; i++)
		if(IsWindow(m_pRunDlg[i]->GetSafeHwnd())){
		   m_pRunDlg[i]->GetWindowRect(&DialogBoxDim);
		   XPos = OldXLocation[i];
		   YPos = OldYLocation[i];
		   m_pRunDlg[i]->MoveWindow(XPos
								   ,YPos
								   ,DialogBoxDim.right - DialogBoxDim.left
								   ,DialogBoxDim.bottom - DialogBoxDim.top);
		   m_pRunDlg[i]->BringWindowToTop();
		}

	if(IsWindow(m_pLaunchDlg->GetSafeHwnd())){		//  Handling Launch Window
	   m_pLaunchDlg->SetWindowPos(&wndTopMost, 0, 0, 0, 0,SWP_NOSIZE | SWP_SHOWWINDOW | SWP_NOMOVE);
	}

	m_bReArrange = FALSE;
}

void CTAgentView::OnUpdateViewUser(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL UserEnable = FALSE;
	for(UINT i = 0 ; i < MAX_THREADS ; i++)
		if(IsWindow(m_pRunDlg[i]->GetSafeHwnd())){
	       UserEnable = m_nWinArrange != ARNG_USER;	
		   break;
		}
	pCmdUI->Enable(UserEnable);
}

void CTAgentView::OnSolutionsArrangesolutions() 
{
	// TODO: Add your command handler code here
	int DlgNumber, DlgWidth;
	CRect ViewRect;
	CWnd *CurrentFocus = GetFocus();

	this->GetWindowRect(&ViewRect);
	CompressSolutions();

	for(int i = 0; i < MAX_SOLUTIONS; i++)
		if(m_pSolutionDlg[i]){
		   DlgWidth = m_DlgWidth;
		   DlgNumber = i;
	       DlgWidth *= (DlgNumber / (MAX_SOLUTIONS / 2));
	       DlgNumber %= (MAX_SOLUTIONS / 2);

	       m_pSolutionDlg[i]->SetWindowPos(&wndTop
									      ,ViewRect.left + DlgWidth + ((DlgNumber + 2) * m_TextHeight)
									      ,ViewRect.top + ((DlgNumber + 2) * m_TextHeight)
									      ,0 ,0 ,SWP_NOACTIVATE | SWP_NOSIZE);
		}											//  End of if(m_pSolutionDlg[i])  ...And For Loop Commands

	for(i = 0 ; i < MAX_THREADS ; i++)				//  Move Search Windows to Top.
		if(IsWindow(m_pRunDlg[i]->GetSafeHwnd())){
		   m_pRunDlg[i]->BringWindowToTop();
		}

	if(IsWindow(m_pWaitingMessageBox->GetSafeHwnd()))
	   m_pWaitingMessageBox->BringWindowToTop();

	if(IsWindow(m_pLaunchDlg->GetSafeHwnd())){		//  Handling Launch Window
	   m_pLaunchDlg->SetWindowPos(&wndTopMost, 0, 0, 0, 0,SWP_NOSIZE | SWP_SHOWWINDOW | SWP_NOMOVE);
	}

	if(CurrentFocus)
	   if(IsWindow(CurrentFocus->GetSafeHwnd()))
	      ::SetFocus(CurrentFocus->GetSafeHwnd());
}												//  End of OnSolutionsArrangesolutions Function

void CTAgentView::OnUpdateSolutionsArrangesolutions(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL ArrangeEnable = TRUE;

	if(!GetNumberOfSolutions())
	   ArrangeEnable = FALSE;

	pCmdUI->Enable(ArrangeEnable);
}

void CTAgentView::OnSolutions10() 
{
	// TODO: Add your command handler code here
	CompressSolutions();

	m_MaxSolutions = 10;

	if(IsWindow(m_pWaitingMessageBox->GetSafeHwnd()))
	   if(m_SolutionsList.GetCount()){
	      m_pWaitingMessageBox->UpdateMessageBox(m_SolutionsList.GetCount());
	   }
	   else m_pWaitingMessageBox->DestroyWindow();
}

void CTAgentView::OnUpdateSolutions10(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL Solutions10Enable = FALSE;

	if(GetNumberOfSolutions() <= 10)
	   Solutions10Enable = TRUE;

	if(m_MaxSolutions == 10)
	   Solutions10Enable = FALSE;

	pCmdUI->Enable(Solutions10Enable);
}

void CTAgentView::OnSolutions20() 
{
	// TODO: Add your command handler code here

	if(m_MaxSolutions < 20){
	   m_MaxSolutions = 20;
	   PostSolutionsFromList();
	}								//  End if(m_MaxSolutions < 20)
	else {
		   	CompressSolutions();
		    m_MaxSolutions = 20;
	}

}

void CTAgentView::OnUpdateSolutions20(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL Solutions20Enable = FALSE;

	if(GetNumberOfSolutions() <= 20)
	   Solutions20Enable = TRUE;

	if(m_MaxSolutions == 20)
	   Solutions20Enable = FALSE;

	pCmdUI->Enable(Solutions20Enable);	
}

void CTAgentView::OnSolutions30() 
{
	// TODO: Add your command handler code here

	if(m_MaxSolutions < 30){
	   m_MaxSolutions = 30;
	   PostSolutionsFromList();
	}								//  End if(m_MaxSolutions < 30)
	else  {
		   	CompressSolutions();
		    m_MaxSolutions = 30;
	}

}

void CTAgentView::OnUpdateSolutions30(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL Solutions30Enable = FALSE;

	if(GetNumberOfSolutions() <= 30)
	   Solutions30Enable = TRUE;

	if(m_MaxSolutions == 30)
	   Solutions30Enable = FALSE;

	pCmdUI->Enable(Solutions30Enable);
}

void CTAgentView::OnSolutions40() 
{
	// TODO: Add your command handler code here

	if(m_MaxSolutions < 40){
	   m_MaxSolutions = 40;
	   PostSolutionsFromList();
	}								//  End if(m_MaxSolutions < 40)
	else {
		   	CompressSolutions();
		    m_MaxSolutions = 40;
	}


}

void CTAgentView::OnUpdateSolutions40(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL Solutions40Enable = FALSE;

	if(GetNumberOfSolutions() <= MAX_SOLUTIONS)
	   Solutions40Enable = TRUE;

	if(m_MaxSolutions == 40)
	   Solutions40Enable = FALSE;

	pCmdUI->Enable(Solutions40Enable);		
}

void CTAgentView::OnSolutionsPostsolutions() 
{
	// TODO: Add your command handler code here
	PostSolutionsFromList();	
}

void CTAgentView::OnUpdateSolutionsPostsolutions(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL PostEnable = FALSE;

	if(GetNumberOfSolutions() < m_MaxSolutions)
	   if(!m_SolutionsList.IsEmpty())
	      PostEnable = TRUE;

	pCmdUI->Enable(PostEnable);	
}

void CTAgentView::OnSolutionsCloseall()
{
	// TODO: Add your command handler code here
	int YesNo = IDYES, i, OpenSolutions = GetNumberOfSolutions();

	CompressSolutions();
	while(OpenSolutions && (YesNo  == IDYES)){ 
	  for(i = 0; i < OpenSolutions; i++)
		  if(m_pSolutionDlg[i])
		     OnCloseSolution(0, i);

	  PostSolutionsFromList();
	  OpenSolutions = GetNumberOfSolutions();
	  if(OpenSolutions)			     //   If New Solutions were Posted
	     YesNo = AfxMessageBox("Close New Posted Solutions?",MB_YESNO);
	}									//  End of while loop...

	if(IsWindow(m_pWaitingMessageBox->GetSafeHwnd()))
	   m_pWaitingMessageBox->BringWindowToTop();
}

void CTAgentView::OnUpdateSolutionsCloseall(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL CloseEnable = TRUE;
	
	for(UINT i = 0; i < MAX_THREADS; i++)			//  Closing Solutions is NOT avaliable while Searches are Running
		if(m_pRunDlg[i]->GetThreadPtr())
		   if(m_pRunDlg[i]->GetDlgItem(ID_SUSPEND)->IsWindowEnabled())
	          CloseEnable = FALSE;

	if(!GetNumberOfSolutions())
	   CloseEnable = FALSE;

	pCmdUI->Enable(CloseEnable);
}

void CTAgentView::OnUpdateAppAbout(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	BOOL EnableAbout = TRUE;
	if(IsWindow(m_pLaunchDlg->GetSafeHwnd()))
	   EnableAbout = FALSE;

	pCmdUI->Enable(EnableAbout);	   
}

void CTAgentView::OnDestroy() 
{
	//  START - Cleaup Memory:
	OnSearchDeleteDeleteall();
	int i, OpenSolutions = GetNumberOfSolutions();

	CompressSolutions();
	while(OpenSolutions){ 
	  for(i = 0; i < OpenSolutions; i++)
		  if(m_pSolutionDlg[i])
		     OnCloseSolution(0, i);

	  PostSolutionsFromList();
	  OpenSolutions = GetNumberOfSolutions();
	}									//  End of while loop...
	//  END - Cleaup Memory.

	CScrollView::OnDestroy();	
	// TODO: Add your message handler code here
}

/////////////////////////////////////////////////////////////////////
//  User Defined Messages Handling  -- START --
LRESULT CTAgentView::OnDeleteSearch(WPARAM wParam,LPARAM lParam){
	UINT SearchNumber = (UINT) lParam;
	if(SearchNumber != NOT_DEFINED)
	   if(m_pRunDlg[SearchNumber]->GetSafeHwnd() != 0){
		  RECT DialogBoxDim;
		  m_pRunDlg[SearchNumber]->GetWindowRect(&DialogBoxDim);

		  if(m_nWinArrange == ARNG_USER){
		     OldXLocation[SearchNumber] = DialogBoxDim.left;
		     OldYLocation[SearchNumber] = DialogBoxDim.top;
		  }
		  
		  if(m_pRunDlg[SearchNumber]->GetTimerAvail())
			 m_pRunDlg[SearchNumber]->KillTimer(SearchNumber);
	      m_pRunDlg[SearchNumber]->DestroyWindow();
		  m_pRunDlg[SearchNumber]->ClearFileName();
		  m_pRunDlg[SearchNumber]->SetThreadPtr(NULL);
		  m_bReArrange = TRUE;
	   }
	   else AfxMessageBox("Search to Delete NOT DEFINED");
	return 0L;
}   //  End of OnDeleteSearch message handling

LRESULT CTAgentView::OnLaunchSearch(WPARAM wParam,LPARAM lParam){
	CWay *SearchDef = (CWay *) (lParam);
	void *FromFile = NULL;
	SREARCHFILEHEADER *p;

	if(m_nWinArrange == ARNG_USER){    //  Reserve Window Location
	   RECT DialogBoxDim;
       m_pLaunchDlg->GetWindowRect(&DialogBoxDim);
	   OldXLaunch = DialogBoxDim.left;
	   OldYLaunch = DialogBoxDim.top;
	   }

	if(wParam == IDOK) m_pLaunchDlg->DestroyWindow();            //  Destroy Selection Window
	   else {													 //  Solutoin From File, Build SearchDef:
			  FromFile = (void *) lParam;
			  p = (SREARCHFILEHEADER *) FromFile;
			  SearchDef = new CWay(p->FirstCity
								  ,p->LastCity
								  ,p->NumberOfCities
								  , FALSE);
			  SearchDef->SetNextCity(p->NumberOfCities-1);
			  p ++;			//  Get Path for SearchDef
			  memcpy((char *) SearchDef->GetPath(), (char *) p, sizeof(long)*SearchDef->GetNumberOfCities());
			}				//		End of else....

	for(UINT i = 0 ; i < MAX_THREADS ; i++)   //  Display New Search Winodw
		if(!(m_pRunDlg[i]->GetThreadPtr()))
	       if(m_pRunDlg[i]->GetSafeHwnd() == 0){
			  m_pRunDlg[i]->Create(i, SearchDef);

			  switch(m_nWinArrange){
			    case ARNG_HORIZONTAL: OnViewHorizontal();
									  break;
				case ARNG_VERTICAL:   OnViewVertical();
									  break;
				case ARNG_USER:       OnViewUser();
					                  break;
				default:			  OnViewHorizontal();   //  Default arrangement
			  }												//  End of switch(WinArrange)
			  if(FromFile){
  			     p = (SREARCHFILEHEADER *) FromFile;
			     m_pRunDlg[i]->InitSearchTime(p->Minutes
										     ,p->Seconds
										     ,p->TCounter);
			  }

			  if(wParam == SEARCH_FROM_FILE)
				 m_pRunDlg[i]->UpdateFileName(FileName.GetBuffer(1));

			  m_pRunDlg[i]->StartSearchThread(SearchDef, FromFile);
			  break;										//  Break loop
		   }		

	return 0L;
}   //  End of OnLaunchSearch message handling

LRESULT CTAgentView::OnCancelLaunch(WPARAM wParam,LPARAM lParam){
	if(m_nWinArrange == ARNG_USER){
	   RECT DialogBoxDim;
	   m_pLaunchDlg->GetWindowRect(&DialogBoxDim);
	   OldXLaunch = DialogBoxDim.left;
	   OldYLaunch = DialogBoxDim.top;
	}

	m_pLaunchDlg->DestroyWindow();            //  Destroy Selection Window
	return 0L;
}   //  End of OnCancelLaunch message handling

LRESULT CTAgentView::OnCloseSolution(WPARAM wParam,LPARAM lParam){
	if(m_pSolutionDlg[lParam] == m_pDisplayedSolution){

	   InvalidateRect(CRect(m_MapTopLeft.cx, m_MapTopLeft.cy - m_TextHeight
		            , m_MapTopLeft.cx + m_MapSizeSource.cx
					, m_MapTopLeft.cy + m_MapSizeSource.cy + m_TextHeight));

	   m_pDisplayedSolution = NULL;
	   }

	m_pSolutionDlg[lParam]->DestroyWindow();            //  Destroy Solution Window
	delete m_pSolutionDlg[lParam];						//  Free Memory Allocation
	m_pSolutionDlg[lParam] = NULL;						//  Free pointer for Use

	if(!m_SolutionsList.IsEmpty())						//  If Solution is wating to be posted
	   OnSolutionReady(FALSE, NULL);
	
	if(IsWindow(m_pWaitingMessageBox->GetSafeHwnd()))
	   if(m_SolutionsList.GetCount()){
		  m_pWaitingMessageBox->UpdateMessageBox(m_SolutionsList.GetCount());
	   }
	   else m_pWaitingMessageBox->DestroyWindow();	

	return 0L;
}   //  End of OnCloseSolution message handling

LRESULT CTAgentView::OnSolutionReady(WPARAM wParam,LPARAM lParam){
	BOOL NewSolution = (BOOL) wParam;
	BOOL Blocked = TRUE;
	CWay *pWay = (CWay *) lParam;
	int i;
	CMainFrame *pFrame = (CMainFrame *) AfxGetApp()->m_pMainWnd;
	CWnd *CurrentFocus;
	if(NewSolution) m_SolutionsList.AddTail(pWay);    //  if solution is not in the list, add it.

	CurrentFocus = GetForegroundWindow();
	if(CurrentFocus){								//  Updating Blocked status
	   if(CurrentFocus == pFrame)
	      Blocked = FALSE;
	   if(CurrentFocus == this)
	      Blocked = FALSE;
	   if(CurrentFocus == m_pLaunchDlg)
	      Blocked = FALSE;
	   for(i = 0; i < MAX_THREADS; i++)
		   if(CurrentFocus == m_pRunDlg[i])
			  Blocked = FALSE;
	   for(i = 0; i < MAX_SOLUTIONS; i++)
		   if(CurrentFocus == m_pSolutionDlg[i])
			  Blocked = FALSE;
	}												//  End - Updating Blocked status

	if(Blocked){
	   i = m_SolutionsList.GetCount();
	   if(i){
	      if(IsWindow(m_pWaitingMessageBox->GetSafeHwnd()))
		     m_pWaitingMessageBox->UpdateMessageBox(i);
		     else m_pWaitingMessageBox->Create(i);
	   }		
		return 0L;							//  if Blocked, no solution posting
	}

	for(i = 0; i < m_MaxSolutions; i++)
		if(!m_pSolutionDlg[i]){
		   pWay = (CWay *) m_SolutionsList.RemoveHead();  //  GetHead  and  Remove node from m_SolutionsList
		   m_pSolutionDlg[i] = new CSolutionDlg(this, pWay, GetDocument()->MapHeader.MapName);
		   delete pWay;			          //  pWay contains SolutionDesc, Delete after Dialog construction
		   CurrentFocus = GetFocus();
		   m_pSolutionDlg[i]->Create(i);
		   if(CurrentFocus)
			  if(IsWindow(CurrentFocus->GetSafeHwnd()))
			     ::SetFocus(CurrentFocus->GetSafeHwnd());

		   SetSolutionSizeAndPosition(m_pSolutionDlg[i], !(NewSolution));
		   NewSolution = FALSE;
		   break;
		}

	
	i = m_SolutionsList.GetCount();
	if(i){
	   if(IsWindow(m_pWaitingMessageBox->GetSafeHwnd()))
		  m_pWaitingMessageBox->UpdateMessageBox(i);
	   else m_pWaitingMessageBox->Create(i);
	}

	if(IsWindow(m_pWaitingMessageBox->GetSafeHwnd()))
	   m_pWaitingMessageBox->BringWindowToTop();

	return 0L;
}   //  End of OnSolutionReady message handling

LRESULT CTAgentView::OnDisplaySolution(WPARAM wParam,LPARAM lParam){
	if(m_pDisplayedSolution)
	   if(m_pDisplayedSolution != ((CSolutionDlg *) lParam))
		  m_pDisplayedSolution->UNcheckDispaly();

	m_pDisplayedSolution = (CSolutionDlg *) lParam;
	InvalidateRect(CRect(m_MapTopLeft.cx, m_MapTopLeft.cy - m_TextHeight
		          , m_MapTopLeft.cx + m_MapSizeSource.cx
				  , m_MapTopLeft.cy + m_MapSizeSource.cy + m_TextHeight));

	return 0L;
}						//  End of OnDisplaySolution Message Handler

LRESULT CTAgentView::OnSolutionPrint(WPARAM wParam,LPARAM lParam){
	m_pPrintedSolution = (CSolutionDlg *) lParam;
	CScrollView::OnFilePrint();

	return 0L;
}						//  End of OnDisplaySolution Message Handler

LRESULT CTAgentView::OnWaitingSolutionsClose(WPARAM wParam,LPARAM lParam){
	m_pWaitingMessageBox->DestroyWindow();

	return 0L;
}

LRESULT CTAgentView::OnSetMaxSolutions(WPARAM wParam,LPARAM lParam){
	CMainFrame *pFrame = (CMainFrame *) AfxGetApp()->m_pMainWnd;

	switch ((int) lParam){
	  case 10: OnSolutions10();
			   break;
	  case 20: OnSolutions20();
			   break;
	  case 30: OnSolutions30();
			   break;
	  case 40: OnSolutions40();
	}

	if((BOOL) wParam) 
	   if(m_SolutionsList.GetCount())
		  PostSolutionsFromList();

	m_pWaitingMessageBox->DestroyWindow();

	if(IsWindow(pFrame->GetSafeHwnd()))
	   ::SetFocus(pFrame->GetSafeHwnd());

	return 0L;
}						//  End of OnSetMaxSolutions Message Handler
//  User Defined Messages Handling  -- END --
/////////////////////////////////////////////////////////////////////