// WaitingSolutions.cpp : implementation file
//

#include "stdafx.h"
#include "TAgent.h"
#include "WaitingSolutions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWaitingSolutions dialog


CWaitingSolutions::CWaitingSolutions(CWnd* pParent /*=NULL*/)
	: CDialog(CWaitingSolutions::IDD, pParent)				//  Modal Constructor
{
	m_pView = NULL;
	//{{AFX_DATA_INIT(CWaitingSolutions)
	m_WatingSolutionsText = _T("");
	//}}AFX_DATA_INIT
}

CWaitingSolutions::CWaitingSolutions(CTAgentView *pView){    //  Modeless constructor
	m_pView = pView;
}

void CWaitingSolutions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWaitingSolutions)
	DDX_Text(pDX, IDC_WAITING_TEXT, m_WatingSolutionsText);
	//}}AFX_DATA_MAP
}

BOOL CWaitingSolutions::Create(int nCount){
	m_WatingSolutionsText.Empty();
	m_WatingSolutionsText.Format("%d Solutions are waiting to be posted\n, please close Solution boxes.", nCount);

	return CDialog::Create(CWaitingSolutions::IDD);
}

BEGIN_MESSAGE_MAP(CWaitingSolutions, CDialog)
	//{{AFX_MSG_MAP(CWaitingSolutions)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_10_SOLUTIONS, On10Solutions)
	ON_BN_CLICKED(IDC_20_SOLUTIONS, On20Solutions)
	ON_BN_CLICKED(IDC_30_SOLUTIONS, On30Solutions)
	ON_BN_CLICKED(IDC_40_SOLUTIONS, On40Solutions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWaitingSolutions message handlers

BOOL CWaitingSolutions::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	UpdateMessageBox(0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CWaitingSolutions::UpdateMessageBox(int nCount){

	int DisplayedSolutions = m_pView->GetNumberOfSolutions();

	switch(DisplayedSolutions / 10){
	  case 3: if(DisplayedSolutions >= 30)
			     GetDlgItem(IDC_30_SOLUTIONS)->EnableWindow(FALSE);
	  case 2: if(DisplayedSolutions >= 20)
			     GetDlgItem(IDC_20_SOLUTIONS)->EnableWindow(FALSE);
	  case 1: if(DisplayedSolutions >= 10)
			     GetDlgItem(IDC_10_SOLUTIONS)->EnableWindow(FALSE);
	}

	switch(m_pView->GetMaxSolutions()){
	  case 10: GetDlgItem(IDC_10_SOLUTIONS)->EnableWindow(FALSE);
			   CheckRadioButton(IDC_10_SOLUTIONS, IDC_40_SOLUTIONS, IDC_10_SOLUTIONS);
			   break;
	  case 20: GetDlgItem(IDC_20_SOLUTIONS)->EnableWindow(FALSE);
			   CheckRadioButton(IDC_10_SOLUTIONS, IDC_40_SOLUTIONS, IDC_20_SOLUTIONS);
			   break;
	  case 30: GetDlgItem(IDC_30_SOLUTIONS)->EnableWindow(FALSE);
			   CheckRadioButton(IDC_10_SOLUTIONS, IDC_40_SOLUTIONS, IDC_30_SOLUTIONS);
			   break;
	  case 40: GetDlgItem(IDC_40_SOLUTIONS)->EnableWindow(FALSE);
			   CheckRadioButton(IDC_10_SOLUTIONS, IDC_40_SOLUTIONS, IDC_40_SOLUTIONS);
	}

	if(DisplayedSolutions == m_pView->GetMaxSolutions()){
	   ((CButton *) GetDlgItem(IDC_POSTSOLUTIONS))->SetCheck(FALSE);
	   GetDlgItem(IDC_POSTSOLUTIONS)->EnableWindow(FALSE);
	   }
	   else {
		  	 ((CButton *) GetDlgItem(IDC_POSTSOLUTIONS))->SetCheck(TRUE);
			 GetDlgItem(IDC_POSTSOLUTIONS)->EnableWindow(TRUE);
			}

	if(nCount){
	   m_WatingSolutionsText.Format("%d Solutions are waiting to be posted\n, please close Solution boxes.", nCount);
	   UpdateData(FALSE);
	   }
}									//  End of UpdateMessageBox Function

void CWaitingSolutions::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if(m_pView != NULL)
	   m_pView->PostMessage(WM_WAITING_SOLUTIONS_CLOSE, IDOK);		//  Modless case - Call OnDelete to delete Search.
	else CDialog::OnClose();										//  Modal case
}
void CWaitingSolutions::On10Solutions() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_10_SOLUTIONS, IDC_40_SOLUTIONS, IDC_10_SOLUTIONS);
}

void CWaitingSolutions::On20Solutions() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_10_SOLUTIONS, IDC_40_SOLUTIONS, IDC_20_SOLUTIONS);
}

void CWaitingSolutions::On30Solutions() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_10_SOLUTIONS, IDC_40_SOLUTIONS, IDC_30_SOLUTIONS);	
}

void CWaitingSolutions::On40Solutions() 
{
	// TODO: Add your control notification handler code here
	CheckRadioButton(IDC_10_SOLUTIONS, IDC_40_SOLUTIONS, IDC_40_SOLUTIONS);	
}

void CWaitingSolutions::OnOK() 
{
	// TODO: Add extra validation here
	if(m_pView != NULL){			//  Modeless Case
	   long NewMaxSolutions;
	   BOOL PostWaiting = ((CButton *) GetDlgItem(IDC_POSTSOLUTIONS))->GetCheck();

	switch(GetCheckedRadioButton(IDC_10_SOLUTIONS, IDC_40_SOLUTIONS)){
	  case IDC_10_SOLUTIONS: NewMaxSolutions = 10;
			   break;
	  case IDC_20_SOLUTIONS: NewMaxSolutions = 20;
			   break;
	  case IDC_30_SOLUTIONS: NewMaxSolutions = 30;
			   break;
	  case IDC_40_SOLUTIONS: NewMaxSolutions = 40;
			   break;
	  default: NewMaxSolutions = 0;
	}

	TRACE("New Max Solutions = %d\n", NewMaxSolutions);
	m_pView->PostMessage(WM_SET_MAX_SOLUTIONS, (WPARAM) PostWaiting, NewMaxSolutions);
	}
	else CDialog::OnOK();			//  Modal case
}
